# -*- coding: utf-8 -*-
import psychopy
psychopy.useVersion('1.90.0')

from psychopy import core, visual, event, gui
import os
import random
import sys
import string
reload(sys)
sys.setdefaultencoding('utf-8') # Ceci évite les problèmes d'utf-8

# boite de dialogue presente au tout debut de la manip pour rentrer les
# données du sujet
myDlg = gui.Dlg(title="Experience Lecture", pos=(200, 400))
myDlg.addText('Infos Sujet', color='Blue')
myDlg.addField('Participant:', 'xx')
myDlg.addField('Session:', 1)
myDlg.show()  # Affichage de la boite de dialogue
if myDlg.OK:
    thisInfo = myDlg.data  # Ici je récupère les données de la boite de dialogue
else:
    print 'user cancelled'


# Pour débugger, on peut afficher la réponse du sujet sur l'output
flag_reponse_output = False

########################################################################
########################################################################
########################################################################

# création de la fenetre d'affichage
myWin = visual.Window(size = (800,600), allowGUI=False,winType='pyglet', fullscr=True, color=[1, 1, 1],
            monitor='testMonitor', units ='deg', screen=0)
########################################################################
########################################################################
########################################################################

# Ouverture du fichier contenant les Questions et les Consignes pour la gestion de la manip

with open('Consignes_debut_S1.txt', 'r') as file_consignes_debut:
    consignes = file_consignes_debut.read()

with open('Consignes_reprise.txt', 'r') as file_consignes_reprise:
    consignes_reprise = file_consignes_reprise.read()

with open('Consignes_fin_S1.txt', 'r') as file_consignes_fin:
    consignes_fin = file_consignes_fin.read()

with open('Swahili_Francais.txt', 'r') as file_texte:
    liste_le_texte = file_texte.readlines()
    
liste_texte = [(i,item.split('\t')[0],item.split('\t')[1].replace('\n','')) for i,item in enumerate(liste_le_texte)]
random.shuffle(liste_texte)


########################################################################
########################################################################
########################################################################

# encodage ajouté pour assurer la compatibilité PC-MAC
encodage = 'UTF-8'

# Objets contenant le texte present sur l' ecran
premiere_paire = liste_texte[0]
separation_paires = '\t\t\t'
texte_lecture = visual.TextStim(myWin, text=unicode(premiere_paire[1] + separation_paires + premiere_paire[2], encodage),#  celui-ci affichera les consignes et les questions
                        units='norm', height=0.12, color='black',
                        pos=[0, 0], alignHoriz='center',wrapWidth = 1.8)

texte_consignes = visual.TextStim(myWin, text=unicode(consignes, encodage),#  celui-ci affichera les consignes et les questions
                        units='norm', height=0.06, color='black',
                        pos=[0, 0], alignHoriz='center',wrapWidth = 1.8)

texte_questions = visual.TextStim(myWin, text=unicode("", encodage), #  celui-ci affichera les consignes et les questions
                        units='norm', height=0.12, color='black',
                        pos=[0, 0.1], alignHoriz='center',wrapWidth = 1.8)

texte_reponse = visual.TextStim(myWin, text=unicode("", encodage), #  celui-ci affichera les consignes et les questions
                        units='norm', height=0.12, color='black',
                        pos=[0, 0.-0.1], alignHoriz='center',wrapWidth = 1.8)

texte_aide = visual.TextStim(myWin, text="",  # cet autre affichera le temps etc
                        units='norm', height=0.12, color='black',
                        pos=[0, 0.0], alignHoriz='center',wrapWidth = 1.5)

########################################################################
########################################################################
########################################################################

#ligne utilisee pour les croix de fixations
line_color = [-1,-1,-1]
taille_ligne_horizontal = 2
taille_ligne_vertical = 2
pos_x = 0
pos_y = 0
line_horizontal = visual.Line(win=myWin,start = (0.0,0.0), end=(0.0,0.0))
line_horizontal.setLineWidth(6.0)
line_horizontal.setLineColor(color=line_color,colorSpace='rgb')
line_vertical = visual.Line(win=myWin,start = (0.0,0.0), end=(0.0,0.0))
line_vertical.setLineWidth(6.0)
line_vertical.setLineColor(color=line_color,colorSpace='rgb')
line_horizontal.setStart([pos_x-0.5*taille_ligne_horizontal,pos_y])
line_horizontal.setEnd([pos_x+0.5*taille_ligne_horizontal,pos_y])
line_vertical.setStart([pos_x,pos_y-0.5*taille_ligne_vertical])
line_vertical.setEnd([pos_x,pos_y+0.5*taille_ligne_vertical])
#
#
def croix_au_centre():

    line_horizontal.draw()
    line_vertical.draw()

# Si le sujet appuie sur ces touches il ne se passe rien celle la est pour les chiffres : ['capslock']
touches_interdites = [['tab'],['exclamation'],
                    ['lctrl'], ['semicolon'],
                    ['rctrl'], ['colon'],
                    ['lctrl'], ['lshift'],
                    ['ralt'], ['comma'],
                    ['lalt'], ['asterisk'],
                    ['space'], ['dollar'],
                    ['menu'], ['less'],['lctrl', 'ralt'],
                    ['lwindows']]

tab_chiffres_clavier = ['1', '2', '3', '4', '5', '6', '7', '8', '9','0']
tab_non_chiffres_clavier = ["&", "e",'"', "'", "(", "-", "e", "_", "c", "a"]

def reponse_du_sujet(liste_bonne_reponse):
    """ Analyse de la réponse et feedback du sujet """

    # Temps debut de la question_actuelle
    temps_question_actuelle = montre.getTime()

    question_repondue = False
    reponse_ecrite = ""
    qualite_reponse = 0
    flag_capslock = False
    if flag_reponse_output:
        print "Reponses possibles :"
        print liste_bonne_reponse
    flag_debut_question = False
    while question_repondue == False:  #Tant que je n'ai pas de reponse a cette question, j'attends
        texte_questions.draw()
        #text_reponse = "R"+u"\u00e9"+"ponse : "
        text_reponse = "?  "
        texte_reponse.setText(text_reponse + reponse_ecrite)
        texte_reponse.draw()
        myWin.flip()
        lettre = event.getKeys() # Je regarde quel bouton a ete appuye
        if lettre not in touches_interdites: 
            # Temps de reponse
            #if flag_debut_question == False:
                #temps_reponse_a_la_question_actuelle = montre.getTime() - temps_question_actuelle
            #else:
                #pass
            if lettre ==['backspace'] : 
                if len(reponse_ecrite) > 0 :
                    reponse_ecrite = reponse_ecrite[:-1]
            elif lettre == ['return']:
                question_repondue = True
                temps_reponse_a_la_question_actuelle = montre.getTime() - temps_question_actuelle
                
            elif lettre == ['escape']:
                question_repondue = True
                qualite_reponse = -1
            else:
                if len(lettre) > 0:
                    if flag_capslock == False:
                        for k in range (len(tab_chiffres_clavier)):
                            if lettre[0] == tab_chiffres_clavier[k]:
                                la_lettre = tab_non_chiffres_clavier[k]
                                #print "je suis la"
                        if lettre[0] == 'rshift' or lettre[0] == "lshift" or lettre[0] == 'capslock':
                            flag_capslock=True
                            lettre[0] = ""
                            la_lettre = lettre[0]
                            #print la_lettre
                        elif lettre[0] not in tab_chiffres_clavier:
                            la_lettre = lettre[0]
                    else:
                        if lettre[0] ==  'rshift' or lettre[0] ==  "lshift" or lettre[0] == 'capslock':
                            flag_capslock=False
                            lettre[0] = ""
                            la_lettre = lettre[0]
                        else:
                            la_lettre = lettre[0].upper()
                    #la_lettre = unicode(lettre[0].replace("num_",""), encodage)
                    reponse_ecrite += la_lettre
                else:
                    pass


    # comparaison avec la bonne réponse
    if reponse_ecrite.upper() in liste_bonne_reponse or reponse_ecrite.lower() in liste_bonne_reponse:
        qualite_reponse = 1
    
    # feedback
    if qualite_reponse : # Si la réponse est bonne
        #texte_aide.setColor((-1, 1,-1),colorSpace = "rgb")
        texte_aide.setText("Bonne "+"r"+u"\u00e9"+"ponse" + "\n\n" + texte_questions.text + "\t\t\t" + liste_bonne_reponse[0])
    else:
        #texte_aide.setColor((1, -1, -1),colorSpace = "rgb")
        texte_aide.setText("Mauvaise "+"r"+u"\u00e9"+"ponse" + "\n\n" + texte_questions.text + "\t\t\t" + liste_bonne_reponse[0])
    
    # feedback de 100 trames (durée variable suivant l'écran)
    if qualite_reponse != -1:
    	t_debut_affichage_feedback = montre.getTime()
        while montre.getTime() - t_debut_affichage_feedback < duree_affichage_feedback:
            texte_aide.draw()
            myWin.flip()
    
    # Nettoyage de la reponse
    event.clearEvents()
    texte_reponse.setText('')
    
    return qualite_reponse,reponse_ecrite,temps_reponse_a_la_question_actuelle

# Objet qui mesure le temps (utilisé ici pour les temps de lecture)
montre = core.Clock()

#Variables qui enregistrent les donnees de la manip
nombre_de_questions = len(liste_texte) # ici 

liste_temps_de_lecture = [] # liste pour stocker les temps de lecture 

liste_reponses=[]
liste_temps_reponses={}
for i in range(nombre_de_questions):
    liste_reponses.append([i,0])
    liste_temps_reponses[i] = [0]
#liste_reponses : liste pour stocker les reponses du sujet et le numero des questions (j'initialise cette liste à 0)
liste = []
liste_bonnes_reponses = []
liste_questions_affichees = []

# Ces flags permettent de determiner si une boucle est finie ou pas
debut_chrono = False
fin_chrono = False
sortie_de_manip = False
toutes_les_questions_repondues = False
fin_de_toute_la_manip = False
n_lecture = 0
compteur_bonnes_reponses = 0
slide_actuelle = 0
temps_affichage_par_paire = 7 # Secondes
duree_affichage_feedback = 3 #Secondes
nombre_de_slides = len(liste_texte)
flag_premier_passage = True
flag_sortie_avant_fin = False
flag_deja_passe_une_fois = False

########################################################################
########################################################################
########################################################################

# Ici se trouve le corps principal de la manip
# Tant que la manip n'est pas finie je fais... (Boucle principale)
while fin_de_toute_la_manip == False : 
    
    # Premieres indications (tant que j'appuie pas sur space, le 
    # texte d'intro est tjs sur l'ecran, cette boucle ne sera faite
    # qu'une seule fois dans la manip
    # Tant que j'appuie pas sur space, le CHRONO ne se declenche pas


    
    while debut_chrono == False:
        texte_consignes.draw()
        myWin.flip()
        reponse = event.getKeys()
        if reponse == ['space']:
            debut_chrono = True
            Temps_debut_lecture = montre.getTime()
        if reponse == ['escape']:
            debut_chrono = True
            fin_de_toute_la_manip = True

    if fin_de_toute_la_manip == False and flag_deja_passe_une_fois == False:
        liste_temps_de_lecture.append([])
      

        for l in range(len(liste_texte)):
            liste_temps_de_lecture[-1].append(0) # Maintenant chaque slide a son temps de lecture 
        n_lecture = n_lecture+1
        
    # Tant que j'appuie pas sur space, le CHRONO ne s'arrete pas
        t_debut_croix = montre.getTime()
        while montre.getTime() - t_debut_croix < 0.5:
            croix_au_centre()
            myWin.flip()
        myWin.flip()
        core.wait(0.5)
        Temps_debut_lecture = montre.getTime()
        while fin_chrono == False:
            # Nouveauté : ici on affiche le texte directement sur la fenêtre d'affichage

            texte_lecture.draw()
            #texte_consignes_questions.draw()
            #texte_aide.setText("Lecture %d \nTemps de lecture : %.2f s"%(n_lecture,montre.getTime()-Temps_debut_lecture))
            #texte_aide.draw()
            myWin.flip()
            reponse = event.getKeys()
            if montre.getTime() - Temps_debut_lecture > temps_affichage_par_paire:
                flag_deja_passe_une_fois = True
                if slide_actuelle == nombre_de_slides - 1:
                    fin_chrono = True
                    Temps_fin_lecture = montre.getTime()
                    liste_temps_de_lecture[-1][slide_actuelle] = Temps_fin_lecture-Temps_debut_lecture
                    slide_actuelle = 0
                    paire_actuelle = liste_texte[slide_actuelle]
                    texte_lecture.setText(paire_actuelle[1] + '\t\t\t'+ paire_actuelle[2])
                    
                else:
                    Temps_fin_lecture = montre.getTime()
                    liste_temps_de_lecture[-1][slide_actuelle] = Temps_fin_lecture-Temps_debut_lecture
                    slide_actuelle += 1
                    paire_actuelle = liste_texte[slide_actuelle]
                    texte_lecture.setText(paire_actuelle[1] + '\t\t\t'+ paire_actuelle[2])
                
                    #print "je suis la"
                    t_debut_croix = montre.getTime()
                    while montre.getTime() - t_debut_croix < 0.5:
                        croix_au_centre()
                        myWin.flip()
                    myWin.flip()
                    core.wait(0.5)
                    Temps_debut_lecture = montre.getTime()
            if reponse == ['escape']:
                fin_chrono = True
                fin_de_toute_la_manip = True
        
    if fin_de_toute_la_manip == False:
        print "Passage par les questions"
        compteur_questions_mal_repondues = 0 # Je cree une variable qui contient les mauvaises reponses a chaque 
        # passage par la boucle des questions
        liste_question_reponse_intermediaire = [] # Je cree une liste de reponses intermediaires
        liste_question_affichee_oui_ou_non = []
        # Dans cette partie, je regarde question par question
        # Si le resultat est 0 pour une des anciennes reponses
        # alors je reaffiche la question et j'attends une nouvelle
        # reponse
        random.shuffle(liste_reponses)
        
        for i in range(len(liste_reponses)):
            question_repondue = False
            if fin_de_toute_la_manip :
                flag_sortie_avant_fin = True
                break
            if liste_reponses[i][1] == 0 : # Je ne reaffiche que les questions mal repondues avant
               
                
                liste_question_affichee_oui_ou_non.append(1)
                indice_question_mal_repondue = liste_reponses[i][0]
                
                #bricolage pour récupérer la question avec le bon indice
                question_actuelle = ''
                for idx in range(len(liste_texte)):
                	if liste_texte[idx][0] == indice_question_mal_repondue:
                		question_actuelle = liste_texte[idx][1]
                		reponse_actuelle = liste_texte[idx][2]

		        #print question_actuelle
                question_actuelle =  unicode(question_actuelle, encodage)
                la_question = question_actuelle#.split('\t')[1]
                
                
                la_reponse_conversion = unicode(reponse_actuelle, encodage).lower()
            	la_reponse_liste = [unicode(reponse_actuelle.replace('\r',''), encodage)]
                    #la_reponse_liste = la_reponse_conversion.split(" ; ")

                texte_questions.setText(la_question)
                reponse = [0,0]
                reponse[0], reponse[1],temps_reponse = reponse_du_sujet(la_reponse_liste)
                
                 # Ici le temps de la reponse est deja la
                if liste_temps_reponses[liste_reponses[i][0]] == [0]: #BOUUUUUUUUUUUUUUUYAAAAAAAA C'ETAIT CA QUI DECONNAIT !!!!!!!!!!!!!
                    liste_temps_reponses[liste_reponses[i][0]][0] = temps_reponse
                else:
                    liste_temps_reponses[liste_reponses[i][0]].append(temps_reponse)
                
                la_reponse_du_sujet = reponse[1]
                if reponse[0] == -1:
                    flag_sortie_avant_fin = True
                    fin_de_toute_la_manip = True
                    break
                if reponse[0] == 1: # 
                    liste_reponses[i][1] = 1
                    question_repondue = True
                    compteur_bonnes_reponses = compteur_bonnes_reponses+1
                    liste_question_reponse_intermediaire.append([indice_question_mal_repondue, question_actuelle, 0, la_reponse_du_sujet,
                                                            la_reponse_conversion])
                if reponse[0] == 0: # 
                    liste_reponses[i][1] = 0
                    question_repondue = True
                    liste_question_reponse_intermediaire.append([indice_question_mal_repondue, question_actuelle, 0, la_reponse_du_sujet,
                                                            la_reponse_conversion])
                    compteur_questions_mal_repondues = compteur_questions_mal_repondues + 1
            else:
                for idx in range(len(liste_texte)):
	        	  if liste_texte[idx][0] == liste_reponses[i][0]:
	        	      reponse_actuelle = liste_texte[idx][2]

                liste_question_reponse_intermediaire.append([liste_reponses[i][0],"_", 1, "_", "_"])
                liste_question_affichee_oui_ou_non.append(0)

        liste_questions_affichees.append(liste_question_affichee_oui_ou_non)
        liste_bonnes_reponses.append(nombre_de_questions-compteur_questions_mal_repondues) # la liste des bonnes reponses est mise a jour
        liste.append(liste_question_reponse_intermediaire) 
        if compteur_questions_mal_repondues == 0 : # Si toutes les questions ont ete bien repondues je peux finir la manip
            fin_de_toute_la_manip = True
        else: # Sinon je recomence tout du debut
            debut_chrono = False
            fin_chrono = False
            texte_consignes.setText(unicode(consignes_reprise, encodage))
    
    # La manip est finie, voici le texte pour sortir de la manip
    if fin_de_toute_la_manip == True:
        texte_consignes.setText(unicode(consignes_fin, encodage))
        # Derniere indication (tant que j'appuie pas sur space, le 
        # texte de la fin de la manip est tjs sur l'ecran
        while sortie_de_manip == False:
            texte_consignes.draw()
            myWin.flip()
            if event.getKeys() == ['space']:
                sortie_de_manip = True

########################################################################
########################################################################
########################################################################

if len(liste_bonnes_reponses) >= 1:
    liste_bonnes_reponses_par_lecture = []
    liste_bonnes_reponses_par_lecture.append(liste_bonnes_reponses[0])
    for i in range(1,len(liste_bonnes_reponses)):
        liste_bonnes_reponses_par_lecture.append(liste_bonnes_reponses[i]-liste_bonnes_reponses[i-1])

########################################################################
    ########################################################################
    ########################################################################
    
    # Voici la premiere ligne dans le fichier d'enregistrement
    tab_char_slides = []
    for i in range(len(liste_texte)):
        tab_char_slides.append("temps_lecture_slide_%d"%(i+1))
    
    # Headers des variables à enregistrer
    Variables = ["participant", "session", "cycle_Numero", "num question", "question",
                 "question_affichee_oui_ou_non", "BRTotal_Accumule", "BRCycle",
                 "reponse_question", "reponse_ecrite", "reponse_attendue", "temps_de_reponse"]
    
    # ajout des slides
    Variables.append("Temps_affichage_paire")
    Variables[-1] = Variables[-1] + "\n"
    
    # Sauvegarde  
    # Ouverture du fichier
    file_sauvegarde = open(thisInfo[0]+"_"+"session_"+"%d"%(thisInfo[1])+".csv","w")
    file_sauvegarde.write("\t".join(Variables))
    
    if flag_sortie_avant_fin == True:
        core.quit()
    else:
        # Enregistrement des donnees
        separation = "\t"
        for i in range(len(liste)):
            for j in range(nombre_de_questions):
                    if i >= len(liste_temps_reponses[liste[i][j][0]]):
                        temps_ecrit = "_"
                    else:
                        temps_ecrit = "%.2f"%liste_temps_reponses[liste[i][j][0]][i]
                    file_sauvegarde.write(thisInfo[0]+separation+"%d"%(thisInfo[1])+ separation+'%d'%(i+1) 
                                          +separation+"%d"%liste[i][j][0] 
                                          +separation+ liste[i][j][1].replace('\r','').replace('\xef\xbb\xbf','').encode(encodage, 'ignore')
                                          +separation+"%d"%liste_questions_affichees[i][j]
                                          +separation+"%d"%liste_bonnes_reponses[i]
                                          +separation+"%d"%liste_bonnes_reponses_par_lecture[i]
                                          +separation+"%d"%liste[i][j][2]
                                          +separation+ liste[i][j][3].encode(encodage, 'ignore')
                                          +separation+ liste[i][j][4].replace('\r','').encode(encodage, 'ignore')
                                          
                                          +separation+temps_ecrit
                                          +separation+"%.2f"%temps_affichage_par_paire
                                          +separation + "\n")
        # Fermeture du fichier de sauvegarde et sortie du programme
        file_sauvegarde.close()
        core.quit()

########################################################################
########################################################################
########################## FIN DE L'EXPERIENCE #########################
########################################################################
########################################################################
########################################################################